﻿using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class JogviszonyAdatokGridModel : IKretaIdentity
    {
        public JogviszonyAdatokGridModel() { }

        public JogviszonyAdatokGridModel(TanuloJogviszonyAdatItemCo itemCo)
        {
            ID = itemCo.ID;
            TanuloNev = itemCo.TanuloNev;
            OktatasiAzonosito = itemCo.OktatasiAzonosito;
            Osztaly = itemCo.Osztaly;
            JogviszonyKezdete = itemCo.JogviszonyKezdete.ToString();
            JogviszonyKeletkezesenekJogcime = itemCo.JogviszonyKeletkezesenekJogcime.ToString();
            JogviszonyVege = itemCo.JogviszonyVege.ToString();
            JogviszonyMegszunesenekJogcime = itemCo.JogviszonyMegszunesenekJogcime;
            JogviszonyTipus = itemCo.JogviszonyTipus;
            Statusz = itemCo.JogviszonnyalRendelkezik.ToString();
            Megjegyzes = itemCo.Megjegyzes;
        }

        public const string TanulokJogviszonyaAdataiExportAttributeId = nameof(TanulokJogviszonyaAdataiExportAttributeId);

        public string ID { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 00, nameof(TanuloResource.TanuloNeve), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.TanuloNeve), ResourceType = typeof(TanuloResource))]
        public string TanuloNev { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 01, nameof(TanuloResource.OktatasiAzonosito), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.OktatasiAzonosito), ResourceType = typeof(TanuloResource))]
        public string OktatasiAzonosito { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 02, nameof(TanuloResource.Osztaly), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.Osztaly), ResourceType = typeof(TanuloResource))]
        public string Osztaly { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 04, nameof(TanuloResource.JogviszonyKezdete), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.JogviszonyKezdete), ResourceType = typeof(TanuloResource))]
        public string JogviszonyKezdete { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 05, nameof(TanuloResource.JogviszonyKeletkezesenekJogcime), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.JogviszonyKeletkezesenekJogcime), ResourceType = typeof(TanuloResource))]
        public string JogviszonyKeletkezesenekJogcime { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 07, nameof(TanuloResource.JogviszonyVege), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.JogviszonyVege), ResourceType = typeof(TanuloResource))]
        public string JogviszonyVege { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 08, nameof(TanuloResource.JogviszonyMegszunesenekJogcime), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.JogviszonyMegszunesenekJogcime), ResourceType = typeof(TanuloResource))]
        public string JogviszonyMegszunesenekJogcime { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 03, nameof(TanuloResource.JogviszonyTipusa), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.JogviszonyTipusa), ResourceType = typeof(TanuloResource))]
        public string JogviszonyTipus { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 09, nameof(TanuloResource.Statusz), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.Statusz), ResourceType = typeof(TanuloResource))]
        public string Statusz { get; set; }

        [SimpleExportColumn(TanulokJogviszonyaAdataiExportAttributeId, 06, nameof(TanuloResource.Megjegyzes), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.Megjegyzes), ResourceType = typeof(TanuloResource))]
        public string Megjegyzes { get; set; }
    }
}
