﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Enums.ManualEnums;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class OsztalyTanuloiGondviselokPopupModel
    {
        [Display(Name = nameof(FelhasznalokResource.FelhasznaloNev), ResourceType = typeof(FelhasznalokResource))]
        public string FelhasznaloNev { get; set; }

        [Display(Name = nameof(FelhasznalokResource.BelepesiDatum), ResourceType = typeof(FelhasznalokResource))]
        public DateTime? UtolsoBelepes { get; set; }

        [Display(Name = nameof(FelhasznalokResource.BelepesiDatumMobil), ResourceType = typeof(FelhasznalokResource))]
        public DateTime? UtolsoBelepesMobil { get; set; }

        public List<EmailModel> EmailCimek { get; set; } = new List<EmailModel>();

        public List<TelefonszamModel> Telefonszamok { get; set; } = new List<TelefonszamModel>();

        public OsztalyTanuloiGondviselokPopupModel(OsztalyTanuloiGondviselokPopupCo co)
        {
            FelhasznaloNev = co.FelhasznaloNev;
            UtolsoBelepes = co.UtolsoBelepes;
            UtolsoBelepesMobil = co.UtolsoBelepesMobil;
            EmailCimek.AddRange(co.EmailCimek.Select(x => new EmailModel() { EmailCim = x.Item2, Alapertelmezett = x.Item1.GetDisplayName(BooleanDisplayFormatEnum.Teljes) }));
            Telefonszamok.AddRange(co.Telefonszamok.Select(x => new TelefonszamModel() { Telefonszam = x.Item2, Alapertelmezett = x.Item1.GetDisplayName(BooleanDisplayFormatEnum.Teljes) }));
        }

        public class TelefonszamModel
        {
            [Display(Name = nameof(TanuloResource.Alapertelmezett), ResourceType = typeof(TanuloResource))]
            public string Alapertelmezett { get; set; }

            [Display(Name = nameof(TanuloResource.Telefonszam), ResourceType = typeof(TanuloResource))]
            public string Telefonszam { get; set; }
        }

        public class EmailModel
        {
            [Display(Name = nameof(TanuloResource.Alapertelmezett), ResourceType = typeof(TanuloResource))]
            public string Alapertelmezett { get; set; }

            [Display(Name = nameof(TanuloResource.EmailCim), ResourceType = typeof(TanuloResource))]
            public string EmailCim { get; set; }
        }
    }
}
