﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Helpers.SystemSettings;
using Kreta.Enums;
using Kreta.Resources;
using Kreta.Web.Helpers;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class OsztalyTanuloiSearchModel
    {
        public OsztalyTanuloiSearchModel()
        {
            if (ClaimData.IsVegyes)
            { FeladatKategoriaId = new SystemSettingsHelper(ConnectionTypeExtensions.GetSessionConnectionType()).GetSystemSettingValue<int>(RendszerBeallitasTipusEnum.Default_Feladat_Kategoria); }
            else
            { FeladatKategoriaId = (int)ClaimData.FeladatKategoriak[0]; }
        }

        [Display(Name = nameof(OsztalyCsoportResource.EllatottKoznevelesiFeladatTipus), ResourceType = typeof(OsztalyCsoportResource))]
        public int? FeladatKategoriaId { get; set; }

        [Display(Name = nameof(TanuloResource.Osztaly), ResourceType = typeof(TanuloResource))]
        public int? OsztalyCsoport { get; set; }

        [Display(Name = nameof(TanuloResource.Nev), ResourceType = typeof(TanuloResource))]
        public string Nev { get; set; }

        [Display(Name = nameof(TanuloResource.AnyjaSzuletesiNev), ResourceType = typeof(TanuloResource))]
        public string AnyjaSzuletesiNev { get; set; }

        [Display(Name = nameof(TanuloResource.SzuletesiHely), ResourceType = typeof(TanuloResource))]
        public string SzuletesiHely { get; set; }

        [Display(Name = nameof(TanuloResource.SzuletesiIdo), ResourceType = typeof(TanuloResource))]
        public DateTime? SzuletesiIdoTol { get; set; }

        [Display(Name = nameof(TanuloResource.SzuletesiIdo), ResourceType = typeof(TanuloResource))]
        public DateTime? SzuletesiIdoIg { get; set; }

        [Display(Name = nameof(TanuloResource.OktatasiAzonosito), ResourceType = typeof(TanuloResource))]
        public string OktatasiAzonosito { get; set; }

        [Display(Name = nameof(TanuloResource.Tankotelezett), ResourceType = typeof(TanuloResource))]
        public int? Tankotelezett { get; set; }

        [Display(Name = nameof(TanuloResource.Tanterv), ResourceType = typeof(TanuloResource))]
        public int? Tanterv { get; set; }

        [Display(Name = nameof(CommonResource.Feladatellatasihely), ResourceType = typeof(CommonResource))]
        public int? FeladatEllatasiHelyId { get; set; }
    }
}
