﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class SzakkepzesiMunkaszerzodesGridModel : IKretaIdentity
    {
        public SzakkepzesiMunkaszerzodesGridModel()
        {

        }

        public SzakkepzesiMunkaszerzodesGridModel(SzakkepzesiMunkaszerzodesItemCo itemCo)
        {
            ID = itemCo.Id.ToString();
            DualisKepzohelyNeve = itemCo.DualisKepzohelyNeve;
            DualisKepzohelyAdoszama = itemCo.DualisKepzohelyAdoszama;
            Kezdete = itemCo.Kezdete;
            Vege = itemCo.Vege;
            NewModifySzakkepzesiMunkaszerzodesSzervezetId = itemCo.SzervezetId;
        }

        public string ID { get; set; }

        [Display(Name = nameof(TanuloResource.DualisKepzohelyNeve), ResourceType = typeof(TanuloResource))]
        public string DualisKepzohelyNeve { get; set; }

        [Display(Name = nameof(TanuloResource.DualisKepzohelyAdoszama), ResourceType = typeof(TanuloResource))]
        public string DualisKepzohelyAdoszama { get; set; }

        [Display(Name = nameof(TanuloResource.SzakkepzesiMunkaszerzodesKezdete), ResourceType = typeof(TanuloResource))]
        [Required(ErrorMessageResourceName = nameof(ErrorResource.Required), ErrorMessageResourceType = typeof(ErrorResource))]
        public DateTime? Kezdete { get; set; }

        [Display(Name = nameof(TanuloResource.SzakkepzesiMunkaszerzodesVege), ResourceType = typeof(TanuloResource))]
        [Required(ErrorMessageResourceName = nameof(ErrorResource.Required), ErrorMessageResourceType = typeof(ErrorResource))]
        public DateTime? Vege { get; set; }

        [Display(Name = nameof(DualisResource.DualisKepzohely), ResourceType = typeof(DualisResource))]
        [Required(ErrorMessageResourceName = nameof(ErrorResource.Required), ErrorMessageResourceType = typeof(ErrorResource))]
        public int? NewModifySzakkepzesiMunkaszerzodesSzervezetId { get; set; }

        public string GridRowStatus { get; set; }
    }
}
