﻿using System.Collections.Generic;
using System.Linq;
using Kreta.Enums.ManualEnums;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloApaczaiDokumentumHozzaadasaModel
    {
        public IList<string> HatranyosHelyzetIgazolasaFajlnevek { get; set; }

        public bool IsHatranyosHelyzetIgazolasaUploaded => HatranyosHelyzetIgazolasaFajlnevek.Any();

        public bool IsHatranyosHelyzetIgazolasaLessThanMax => HatranyosHelyzetIgazolasaFajlnevek.Count < KategoriankentiMaxFajlSzam;

        public bool IsHatranyosHelyzetEnable => IsHatranyosHelyzetIgazolasaLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);

        public IList<string> HozzajaruloNyilatkozatFajlnevek { get; set; }

        public bool IsHozzajaruloNyilatkozatUploaded => HozzajaruloNyilatkozatFajlnevek.Any();

        public bool IsHozzajaruloNyilatkozatLessThanMax => HozzajaruloNyilatkozatFajlnevek.Count < KategoriankentiMaxFajlSzam;

        public bool IsHozzajaruloNyilatkozatEnable => IsHozzajaruloNyilatkozatLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);

        public IList<string> MentoriTamogatoNyilatkozatFajlnevek { get; set; }

        public bool IsMentoriTamogatoNyilatkozatUploaded => MentoriTamogatoNyilatkozatFajlnevek.Any();

        public bool IsMentoriTamogatoNyilatkozatLessThanMax => MentoriTamogatoNyilatkozatFajlnevek.Count < KategoriankentiMaxFajlSzam;

        public bool IsMentoriTamogatoNyilatkozatEnable => IsMentoriTamogatoNyilatkozatLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);

        public IList<string> EgyebDokumentumFajlnevek { get; set; }

        public bool IsEgyebDokumentumUploaded => EgyebDokumentumFajlnevek.Any();

        public bool IsEgyebDokumentumLessThanMax => EgyebDokumentumFajlnevek.Count < KategoriankentiMaxFajlSzam;
        public bool IsEgyebDokumentumEnable => IsEgyebDokumentumLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.Elfogadott);

        public IList<string> ElozoTanevEvvegiBizonyitvanyFajlnevek { get; set; }

        public bool IsElozoTanevEvvegiBizonyitvanyUploaded => ElozoTanevEvvegiBizonyitvanyFajlnevek.Any();

        public bool IsElozoTanevEvvegiBizonyitvanyLessThanMax => ElozoTanevEvvegiBizonyitvanyFajlnevek.Count < KategoriankentiMaxFajlSzam;

        public bool IsElozoTanevEvvegiBizonyitvanyEnable => IsElozoTanevEvvegiBizonyitvanyLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);

        public IEnumerable<string> AllowedFileExtensions { get; set; }

        public int KategoriankentiMaxFajlSzam => Core.Constants.MinMaxValues.MaxApaczaiKategoriankentFeltotlhetoFajlokSzama;

        public ApaczaiPalyazatStatuszEnum? PalyazatStatusz { get; set; }

        public TanuloApaczaiDokumentumHozzaadasaModel()
        {
            HatranyosHelyzetIgazolasaFajlnevek = new List<string>();
            HozzajaruloNyilatkozatFajlnevek = new List<string>();
            MentoriTamogatoNyilatkozatFajlnevek = new List<string>();
            EgyebDokumentumFajlnevek = new List<string>();
            ElozoTanevEvvegiBizonyitvanyFajlnevek = new List<string>();

            AllowedFileExtensions = Constants.UploadFile.ApaczaiAllowedFileExtensions;
        }
    }
}
