﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloApaczaiOsztondijBaseGridModel : IKretaIdentity
    {
        public const string ApaczaiIgenylesekExportAttributeId = nameof(ApaczaiIgenylesekExportAttributeId);
        public const string ApaczaiKifizetesekExportAttributeId = nameof(ApaczaiKifizetesekExportAttributeId);
        public const string ApaczaiTanuloiListaExportAttributeId = nameof(ApaczaiTanuloiListaExportAttributeId);

        public string ID { get; set; }

        [SimpleExportColumn(ApaczaiIgenylesekExportAttributeId, 00, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameTanuloNeve), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiKifizetesekExportAttributeId, 00, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameTanuloNeve), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiTanuloiListaExportAttributeId, 00, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameTanuloNeve), typeof(SzakkepzesiJuttatasokResource))]
        [Display(Name = nameof(TanuloResource.TanuloNeve), ResourceType = typeof(TanuloResource))]
        public string TanuloNeve { get; set; }

        [SimpleExportColumn(ApaczaiIgenylesekExportAttributeId, 01, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOktatasiAzonosito), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiKifizetesekExportAttributeId, 01, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOktatasiAzonosito), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiTanuloiListaExportAttributeId, 01, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOktatasiAzonosito), typeof(SzakkepzesiJuttatasokResource))]
        [Display(Name = nameof(TanuloResource.OktatasiAzonosito), ResourceType = typeof(TanuloResource))]
        public string OktatasiAzonosito { get; set; }

        [SimpleExportColumn(ApaczaiIgenylesekExportAttributeId, 02, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameSzuletesiIdo), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiKifizetesekExportAttributeId, 02, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameSzuletesiIdo), typeof(SzakkepzesiJuttatasokResource))]
        [Display(Name = nameof(TanuloResource.SzuletesiIdo), ResourceType = typeof(TanuloResource))]
        public DateTime SzuletesiIdeje { get; set; }

        [SimpleExportColumn(ApaczaiIgenylesekExportAttributeId, 03, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOsztaly), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiKifizetesekExportAttributeId, 03, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOsztaly), typeof(SzakkepzesiJuttatasokResource))]
        [Display(Name = nameof(TanuloResource.Osztaly), ResourceType = typeof(TanuloResource))]
        public string Osztaly { get; set; }

        [SimpleExportColumn(ApaczaiIgenylesekExportAttributeId, 04, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameEvfolyam), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(ApaczaiKifizetesekExportAttributeId, 04, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameEvfolyam), typeof(SzakkepzesiJuttatasokResource))]
        [Display(Name = nameof(TanuloResource.Evfolyam), ResourceType = typeof(TanuloResource))]
        public string EvfolyamNev { get; set; }
    }
}
