﻿using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses.ApaczaiProgramCOs;
using Kreta.Core.CustomAttributes;
using Kreta.Enums.ManualEnums;
using Kreta.Resources;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloApaczaiOsztondijTanuloiListaGridModel : TanuloApaczaiOsztondijBaseGridModel
    {
        public TanuloApaczaiOsztondijTanuloiListaGridModel()
        {

        }

        public TanuloApaczaiOsztondijTanuloiListaGridModel(TanuloApaczaiTanuloListaItemCo co)
        {
            TanuloNeve = co.TanuloNeve;
            OktatasiAzonosito = co.OktatasiAzonosito;
            Osztaly = co.Osztaly;
            EvfolyamNev = co.EvfolyamNeve;
            SzuletesiIdeje = co.SzuletesiIdeje.Value;
            PalyazatKgrAllapota = co.PalyazatKgrAllapota;
            Jogosultsag = co.Jogosultsag.GetDisplayName();
            NemJogosultsagOka = co.NemJogosultsagOka_STR;
            JuttatasOsszege = co.JuttatasOsszege;
            MentorNeve = co.MentorNeve;
        }

        [SimpleExportColumn(ApaczaiTanuloiListaExportAttributeId, 05, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNamePalyazatAllapota), typeof(SzakkepzesiJuttatasokResource))]
        [Display(Name = nameof(SzakkepzesiJuttatasokResource.PalyazatAllapota), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public string PalyazatKgrAllapota { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.Jogosultsag), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public string Jogosultsag { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.NemJogosultsagOka), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public string NemJogosultsagOka { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.JuttatasOsszege), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public int? JuttatasOsszege { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.MentorNeve), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public string MentorNeve { get; set; }
    }
}
