﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Kreta.Enums.ManualEnums;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloApaczaiPalyazatBenyujtasAtlagokContentModel : Web.Models.EditorTemplates.PanelBarChildModel
    {
        [Display(Name = nameof(TanuloApaczaiResource.SzamitottAtlag), ResourceType = typeof(TanuloApaczaiResource))]
        public double? SzamitottAtlag { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.KeziAtlag), ResourceType = typeof(TanuloApaczaiResource))]
        public double? KeziAtlag { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.HatranyosHelyzetIgazolasKiallitasDatuma), ResourceType = typeof(TanuloApaczaiResource))]
        public int? HatranyosHelyzetIgazolasKiallitasDatuma { get; set; }
        public ApaczaiPalyazatStatuszEnum? PalyazatStatusz { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.Feljegyzes), ResourceType = typeof(TanuloApaczaiResource))]
        [MaxLength(4000, ErrorMessageResourceName = nameof(CommonResource.MaxLengthValidation), ErrorMessageResourceType = typeof(CommonResource))]
        public string Feljegyzes { get; set; }

        public int CountElozoTanevEvvegiBizonyitvany { get; set; }

        public int KategoriankentiMaxFajlSzam => Core.Constants.MinMaxValues.MaxApaczaiKategoriankentFeltotlhetoFajlokSzama;
        public bool IsElozoTanevEvvegiBizonyitvanyEnable => CountElozoTanevEvvegiBizonyitvany < KategoriankentiMaxFajlSzam
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);

        public IEnumerable<string> AllowedFileExtensions { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.NyilatkozatValosAdatokrol), ResourceType = typeof(TanuloApaczaiResource))]
        public bool NyilatkozatValosAdatokrol { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.NyilatkozatHitelesAdatokrol), ResourceType = typeof(TanuloApaczaiResource))]
        public bool NyilatkozatHitelesAdatokrol { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.NyilatkozatKotelezettsegVallalasMentor), ResourceType = typeof(TanuloApaczaiResource))]
        public bool NyilatkozatKotelezettsegVallalasMentor { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.NyilatkozatSzakkepzesKeretebenNincsEvVegiMinosites), ResourceType = typeof(TanuloApaczaiResource))]
        public bool NyilatkozatSzakkepzesKeretebenNincsEvVegiMinosites { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.NyilatkozatSzabalyzatElolvasasarol), ResourceType = typeof(TanuloApaczaiResource))]
        public bool NyilatkozatSzabalyzatElolvasasarol { get; set; }

        [Display(Name = nameof(TanuloApaczaiResource.NyilatkozatSzemelyesAdatokKozleserol), ResourceType = typeof(TanuloApaczaiResource))]
        public bool NyilatkozatSzemelyesAdatokKozleserol { get; set; }

        public bool IsReadOnly { get; set; } = false;

        public TanuloApaczaiPalyazatBenyujtasAtlagokContentModel()
        {
            AllowedFileExtensions = Constants.UploadFile.ApaczaiAllowedFileExtensions;
        }
    }
}
