﻿using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses.ApaczaiProgramCOs;
using Kreta.Enums;
using Kreta.Web.Areas.Adminisztracio.Models;
using Kreta.Web.Models;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloApaczaiPalyazatBenyujtasContentModel
    {
        public SajatAdatlapInfoModel AlapAdatModel { get; set; }
        public CimElerhetosegModel ElerhetosegModel { get; set; }
        public TanuloBankszamlaModel BankszamlaModel { get; set; }
        public TanuloApaczaiAtlagokModel AtlagokModel { get; set; }
        public TanuloApaczaiDokumentumokModel DokumentumokModel { get; set; }

        public TanuloAdatokCo ConvertToCo()
        {
            return new TanuloAdatokCo
            {
                Allampolgarsag = AlapAdatModel.AlapAdat.Allampolgarsag,
                Allampolgarsag2 = AlapAdatModel.AlapAdat.Allampolgarsag2,
                Anyanyelv = AlapAdatModel.AlapAdat.Anyanyelv,
                AnyjaCsaladiNeve = AlapAdatModel.AlapAdat.AnyjaCsaladiNeve,
                AnyjaUtonev = AlapAdatModel.AlapAdat.AnyjaUtonev,
                CsaladiNev = AlapAdatModel.AlapAdat.CsaladiNev,
                EloTag = AlapAdatModel.AlapAdat.EloTag,
                IgazolvanySzam = AlapAdatModel.AlapAdat.IgazolvanySzam,
                IgazolvanyTipus = AlapAdatModel.AlapAdat.IgazolvanyTipus,
                OktatasiAzonosito = AlapAdatModel.AlapAdat.OktatasiAzonosito,
                SzuletesiCsaladNev = AlapAdatModel.AlapAdat.SzuletesiCsaladNev,
                SzuletesiHely = AlapAdatModel.AlapAdat.SzuletesiHely,
                SzuletesiIdo = AlapAdatModel.AlapAdat.SzuletesiIdo,
                SzuletesiOrszag = AlapAdatModel.AlapAdat.SzuletesiOrszag,
                SzuletesiUtonev = AlapAdatModel.AlapAdat.SzuletesiUtonev,
                Utonev = AlapAdatModel.AlapAdat.Utonev,
                TAJSzam = AlapAdatModel.TanuloIgazolvany.TajSzam,
                AllandoElerhetoseg = new TanuloElerhetosegAdatokCo
                {
                    Orszag = ElerhetosegModel.OrszagStr,
                    CimTipus = ElerhetosegModel.CimTipusStr,
                    Iranyitoszam = ElerhetosegModel.Iranyitoszam,
                    HelysegNev = ElerhetosegModel.HelysegNev_Str,
                    KozteruletNev = ElerhetosegModel.KozteruletNev,
                    KozteruletTipus = ElerhetosegModel.KozteruletTipus_Str,
                    Hazszam = ElerhetosegModel.Hazszam,
                    Emelet = ElerhetosegModel.Emelet,
                    Ajto = ElerhetosegModel.Ajto,
                    TelefonSzam = ElerhetosegModel.Telefon ?? "-",
                    TelefonTipus = ElerhetosegModel.TelefonTipusStr,
                    Emailcim = ElerhetosegModel.Emailcim ?? "-",
                    EmailTipus = ElerhetosegModel.EmailTipusStr,
                },
                TartozkodasiElerhetoseg = new TanuloElerhetosegAdatokCo
                {
                    Orszag = ElerhetosegModel.TartozkodasiOrszagStr,
                    CimTipus = ElerhetosegModel.TartozkodasiCimTipusStr,
                    Iranyitoszam = ElerhetosegModel.TartozkodasiIranyitoszam,
                    HelysegNev = ElerhetosegModel.TartozkodasiHelysegNev,
                    KozteruletNev = ElerhetosegModel.TartozkodasiKozteruletNev,
                    KozteruletTipus = ElerhetosegModel.TartozkodasiKozteruletTipusNev,
                    Hazszam = ElerhetosegModel.TartozkodasiHazszam,
                    Emelet = ElerhetosegModel.TartozkodasiEmelet,
                    Ajto = ElerhetosegModel.TartozkodasiAjto,
                    TelefonSzam = ElerhetosegModel.Telefon2 ?? "-",
                    TelefonTipus = ElerhetosegModel.TelefonTipus2Str,
                    Emailcim = ElerhetosegModel.Emailcim ?? "-",
                    EmailTipus = ElerhetosegModel.EmailTipusStr,
                },
                BankszamlaSzam = AlapAdatModel.TanuloBankszamla.BankszamlaSzam,
                BankszamlaTulajdonos = AlapAdatModel.TanuloBankszamla.BankszamlaTulajdonos.GetDisplayName<BankszamlaTulajdonosTipusEnum>(ClaimData.SelectedTanevID.Value),
                BankszamlaTulajdonosNeve = AlapAdatModel.TanuloBankszamla.BankszamlaTulajdonosNeve,
                SzamlavezetoBank = AlapAdatModel.TanuloBankszamla.SzamlavezetoBank ?? "-",

                KeziAtlag = AtlagokModel.KeziAtlag,
                SzamitottAtlag = AtlagokModel.SzamitottAtlag,
                Feljegyzes = AtlagokModel.Feljegyzes,
                HatranyosHelyzetIgazolasKiallitasDatuma = AtlagokModel.HatranyosHelyzetIgazolasKiallitasDatuma.Value,
                PalyazatStatusz = AtlagokModel.PalyazatStatusz
            };
        }
    }
}
