﻿using System.Collections.Generic;
using Kreta.Enums.ManualEnums;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloApaczaiPalyazatBenyujtasDokumentumokContentModel : Web.Models.EditorTemplates.PanelBarChildModel
    {
        public string HozzajaruloDokumentum { get; set; } = TanuloApaczaiResource.HozzajaruloNyilatkozat;
        public string HatranyosHelyzetetIgazoloDokumentum { get; set; } = TanuloApaczaiResource.HatranyosHelyzetIgazolasa;
        public string MentoriTamogatoNyilatkozat { get; set; } = TanuloApaczaiResource.MentoriTamogatoNyilatkozat;
        public string EgyebDokumentum { get; set; } = TanuloApaczaiResource.EgyebDokumentum;
        public string ElozoTanevEvvegiBizonyitvany { get; set; } = TanuloApaczaiResource.ElozoTanevEvvegiBizonyitvany;
        public int CountHozzajaruloDokumentum { get; set; }
        public bool IsHozzajaruloNyilatkozatLessThanMax => CountHozzajaruloDokumentum < KategoriankentiMaxFajlSzam;
        public bool IsHozzajaruloNyilatkozatEnable => IsHozzajaruloNyilatkozatLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);
        public int CountHatranyosHelyzetIgazolas { get; set; }
        public bool IsHatranyosHelyzetIgazolasaLessThanMax => CountHatranyosHelyzetIgazolas < KategoriankentiMaxFajlSzam;
        public bool IsHatranyosHelyzetEnabled => IsHatranyosHelyzetIgazolasaLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);
        public int CountMentoriTamogatoNyilatkozat { get; set; }
        public bool IsMentoriTamogatoNyilatkozatLessThanMax => CountMentoriTamogatoNyilatkozat < KategoriankentiMaxFajlSzam;
        public bool IsMentoriTamogatoNyilatkozatEnabled => IsMentoriTamogatoNyilatkozatLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);
        public int CountEgyebDokumentum { get; set; }
        public bool IsEgyebDokumentumLessThanMax => CountEgyebDokumentum < KategoriankentiMaxFajlSzam;
        public bool IsEgyebDokumentumEnable => IsEgyebDokumentumLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.Elfogadott);
        public int CountElozoTanevEvvegiBizonyitvany { get; set; }
        public bool IsElozoTanevEvvegiBizonyitvanyLessThanMax => CountElozoTanevEvvegiBizonyitvany < KategoriankentiMaxFajlSzam;

        public bool IsElozoTanevEvvegiBizonyitvanyEnable => IsElozoTanevEvvegiBizonyitvanyLessThanMax
            && (!PalyazatStatusz.HasValue
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.AdategyeztetesreVisszakuldve
                || PalyazatStatusz == ApaczaiPalyazatStatuszEnum.FelulvizsgalatrolAdategyeztetesreVisszakuldve);
        public int KategoriankentiMaxFajlSzam => Core.Constants.MinMaxValues.MaxApaczaiKategoriankentFeltotlhetoFajlokSzama;

        public IEnumerable<string> AllowedFileExtensions { get; } = Constants.UploadFile.ApaczaiAllowedFileExtensions;
        public bool UploadAllowed { get; set; }

        public ApaczaiPalyazatStatuszEnum? PalyazatStatusz { get; set; }
    }
}
