﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloEgyszeriPalyakezdesiJuttatasGridModel : TanuloSzakkepzesiJuttatasGridModel
    {
        public TanuloEgyszeriPalyakezdesiJuttatasGridModel()
            : base()
        {

        }

        public TanuloEgyszeriPalyakezdesiJuttatasGridModel(TanuloEgyszeriPalyakezdesiJuttatasItemCo juttatasCO)
            : base(juttatasCO)
        {
            ErdemjegyMinimumAlatt = juttatasCO.ErdemjegyMinimumAlatt;
            JuttatasMeghatarozasraKerult = juttatasCO.JuttatasMeghatarozasraKerult;
            NincsEpjAdata = juttatasCO.NincsEpjAdata;
            SzakmaiVizsgaEredmenye = juttatasCO.SzakmaiVizsgaEredmenye;
            SzakmaiVizsgaSzakkepesitesMegnevezese = juttatasCO.SzakmaiVizsgaSzakkepesitesMegnevezese;
            SzakmaiVizsgaSzakkepesitesAzonosito = juttatasCO.SzakmaiVizsgaSzakkepesitesAzonosito;
            IsJavitoVizsga_BNAME = juttatasCO.IsJavitoVizsga.GetDisplayName();
            IsPotloVizsga_BNAME = juttatasCO.IsPotloVizsga.GetDisplayName();
            VizsgaDatum = juttatasCO.VizsgaDatum;
            BizonyitvanySzama = juttatasCO.BizonyitvanySzama;
        }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaEredmenye), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 07, nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaErdemjegye), typeof(SzakkepzesiJuttatasokResource))]
        public double? SzakmaiVizsgaEredmenye { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaSzakkepesitesMegnevezese), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 08, nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaSzakkepesitesMegnevezese), typeof(SzakkepzesiJuttatasokResource))]
        public string SzakmaiVizsgaSzakkepesitesMegnevezese { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 09, nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaSzakkepesitesAzonosito), typeof(SzakkepzesiJuttatasokResource))]
        public string SzakmaiVizsgaSzakkepesitesAzonosito { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 12, nameof(SzakkepzesiJuttatasokResource.JavitoVizsgazo), typeof(SzakkepzesiJuttatasokResource))]
        public string IsJavitoVizsga_BNAME { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 13, nameof(SzakkepzesiJuttatasokResource.PotloVizsgazo), typeof(SzakkepzesiJuttatasokResource))]
        public string IsPotloVizsga_BNAME { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 10, nameof(SzakkepzesiJuttatasokResource.AVizsgaDatuma), typeof(SzakkepzesiJuttatasokResource))]
        public DateTime? VizsgaDatum { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 11, nameof(SzakkepzesiJuttatasokResource.BizonyitvanySzama), typeof(SzakkepzesiJuttatasokResource))]
        public string BizonyitvanySzama { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 18, nameof(SzakkepzesiJuttatasokResource.ErdemjegyMinimumAlatt), typeof(SzakkepzesiJuttatasokResource))]
        public string ErdemjegyMinimumAlatt { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 19, nameof(SzakkepzesiJuttatasokResource.MeghatarozasraKerultAJuttatas), typeof(SzakkepzesiJuttatasokResource))]
        public string JuttatasMeghatarozasraKerult { get; set; }

        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 20, nameof(SzakkepzesiJuttatasokResource.NincsEpjAdata), typeof(SzakkepzesiJuttatasokResource))]
        public string NincsEpjAdata { get; set; }
    }
}
