﻿using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloEgyszeriPalyakezdesiJuttatasSearchModel : TanuloSzakkepzesiJuttatasSearchModel
    {
        [Display(Name = nameof(SzakkepzesiJuttatasokResource.JuttatasOsszege), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public int? JuttatasOsszege { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaEredmenye), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        [Range(1.0, 5.0)]
        public double? SzakmaiVizsgaEredmenyeTol { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaEredmenye), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        [Range(1.0, 5.0)]
        public double? SzakmaiVizsgaEredmenyeIg { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.SzakmaiVizsgaSzakkepesitesMegnevezese), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public string SzakmaiVizsgaSzakkepesitesMegnevezese { get; set; }

        public TanuloEgyszeriPalyakezdesiJuttatasKeresesCO ConvertModelToCo()
        {
            return new TanuloEgyszeriPalyakezdesiJuttatasKeresesCO()
            {
                TanuloNeve = this.TanuloNeve,
                OktatasiAzonosito = this.OktatasiAzonosito,
                OsztalyId = this.OsztalyId,
                EvfolyamId = this.Evfolyam,
                SzakmaiVizsgaEredmenyeTol = this.SzakmaiVizsgaEredmenyeTol,
                SzakmaiVizsgaEredmenyeIg = this.SzakmaiVizsgaEredmenyeIg,
                SzakmaiVizsgaSzakkepesitesMegnevezese = this.SzakmaiVizsgaSzakkepesitesMegnevezese,
                JuttatasOsszege = this.JuttatasOsszege,
            };
        }

    }
}
