﻿using System;
using System.ComponentModel.DataAnnotations;
using System.Data;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloHaziFeladatGridModel : IKretaIdentity
    {
        public const string TanuloHaziFeladatExportAttributeId = nameof(TanuloHaziFeladatExportAttributeId);

        public TanuloHaziFeladatGridModel() { }

        public TanuloHaziFeladatGridModel(DataRow dr)
        {
            TantargyNev = dr.Field<string>("TantargyNev");
            TanarNeve = dr.Field<string>("TanarNeve");
            HaziFeladatSzoveg = dr.Field<string>("HaziFeladatSzoveg");
            HaziFeladatTenylegesRogzitesDatumaStr = dr.Field<DateTime>("HaziFeladatTenylegesRogzitesDatuma").ToString(Core.Constants.ToStringPattern.HungarianDate);
            HaziFeladatHataridoStr = dr.Field<DateTime>("HaziFeladatHatarido").ToString(Core.Constants.ToStringPattern.HungarianDate);
        }

        public string ID { get; set; }

        public int TantargyId { get; set; }

        [SimpleExportColumn(TanuloHaziFeladatExportAttributeId, 00, nameof(TanuloResource.Tantargy), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.Tantargy), ResourceType = typeof(TanuloResource))]
        public string TantargyNev { get; set; }

        public bool isTanitasiOra_BOOL { get; set; }

        public int EventId { get; set; }

        [SimpleExportColumn(TanuloHaziFeladatExportAttributeId, 01, nameof(TanuloResource.Tanar), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.Tanar), ResourceType = typeof(TanuloResource))]
        public string TanarNeve { get; set; }

        [SimpleExportColumn(TanuloHaziFeladatExportAttributeId, 02, nameof(TanuloResource.HaziFeladatLeiras), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.HaziFeladatLeiras), ResourceType = typeof(TanuloResource))]
        public string HaziFeladatSzoveg { get; set; }

        [Display(Name = nameof(TanuloResource.HaziFeladatRogzitesDatuma), ResourceType = typeof(TanuloResource))]
        public DateTime HaziFeladatTenylegesRogzitesDatuma { get; set; }

        [SimpleExportColumn(TanuloHaziFeladatExportAttributeId, 04, nameof(TanuloResource.HaziFeladatHatarido), typeof(TanuloResource))]
        [Display(Name = nameof(TanuloResource.HaziFeladatHatarido), ResourceType = typeof(TanuloResource))]
        public DateTime HaziFeladatHatarido { get; set; }

        [Display(Name = nameof(TanuloResource.MegoldottHF), ResourceType = typeof(TanuloResource))]
        public string MegoldottHF { get; set; }

        [SimpleExportColumn(TanuloHaziFeladatExportAttributeId, 03, nameof(TanuloResource.HaziFeladatRogzitesDatuma), typeof(TanuloResource))]
        public string HaziFeladatTenylegesRogzitesDatumaStr { get; set; }

        [SimpleExportColumn(TanuloHaziFeladatExportAttributeId, 04, nameof(TanuloResource.HaziFeladatHatarido), typeof(TanuloResource))]
        public string HaziFeladatHataridoStr { get; set; }
    }
}
