﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloHaziFeladatSearchModel
    {
        [Display(Name = nameof(TanuloResource.Tanar), ResourceType = typeof(TanuloResource))]
        public string TanarNev { get; set; }

        [Display(Name = nameof(TanuloResource.Tantargy), ResourceType = typeof(TanuloResource))]
        public int? TantargyId { get; set; }

        [Display(Name = nameof(TanuloResource.HaziFeladatHatarido), ResourceType = typeof(TanuloResource))]
        public DateTime? HaziFeladatHataridoKezdoDatum { get; set; }

        public DateTime? HaziFeladatHatairdo { get; set; }

        [Display(Name = nameof(TanuloResource.RegiHaziFeladatokElrejtese), ResourceType = typeof(TanuloResource))]
        public bool RegiHaziFeladatokElrejtese { get; set; } = true;

        public TanuloHaziFeladatSearchCO ConvertModelToCo()
        {
            return new TanuloHaziFeladatSearchCO
            {
                TanarNev = TanarNev,
                TantargyId = TantargyId,
                HaziFeladatHataridoKezdoDatum = HaziFeladatHataridoKezdoDatum,
                HaziFeladatHatairdo = HaziFeladatHatairdo,
                RegiHaziFeladatokElrejtese = RegiHaziFeladatokElrejtese
            };
        }
    }
}
