﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloJogviszonyAdatokSearchModel
    {
        [Display(Name = nameof(TanuloResource.TanuloNeve), ResourceType = typeof(TanuloResource))]
        public string TanuloNev { get; set; }

        [Display(Name = nameof(TanuloResource.OktatasiAzonosito), ResourceType = typeof(TanuloResource))]
        public string OktatasiAzonosito { get; set; }

        [Display(Name = nameof(TanuloResource.Osztaly), ResourceType = typeof(TanuloResource))]
        public int? OsztalyId { get; set; }

        [Display(Name = nameof(TanuloResource.JogviszonyKezdete), ResourceType = typeof(TanuloResource))]
        public DateTime? JogviszonyKezdeteDateFrom { get; set; }
        public DateTime? JogviszonyKezdeteDateTo { get; set; }

        [Display(Name = nameof(TanuloResource.JogviszonyKeletkezesenekJogcime), ResourceType = typeof(TanuloResource))]
        public int? JogviszonyKeletkezesenekJogcimeId { get; set; }

        [Display(Name = nameof(TanuloResource.JogviszonyVege), ResourceType = typeof(TanuloResource))]
        public DateTime? JogviszonyVegeDateFrom { get; set; }
        public DateTime? JogviszonyVegeDateTo { get; set; }

        [Display(Name = nameof(TanuloResource.JogviszonyMegszunesenekJogcime), ResourceType = typeof(TanuloResource))]
        public int? JogviszonyMegszunesenekJogcimeId { get; set; }

        [Display(Name = nameof(TanuloResource.JogviszonyTipusa), ResourceType = typeof(TanuloResource))]
        public int? JogviszonyTipusId { get; set; }

        [Display(Name = nameof(TanuloResource.JogviszonyStatusza), ResourceType = typeof(TanuloResource))]
        public int? JogviszonyStatuszId { get; set; }

        public TanuloJogviszonyAdatokSearchCO ConvertToCo()
        {
            return new TanuloJogviszonyAdatokSearchCO
            {
                TanuloNev = this.TanuloNev,
                OktatasiAzonosito = this.OktatasiAzonosito,
                OsztalyId = this.OsztalyId,
                JogviszonyKezdeteDateFrom = this.JogviszonyKezdeteDateFrom,
                JogviszonyKezdeteDateTo = this.JogviszonyKezdeteDateTo,
                JogviszonyKeletkezesenekJogcimeId = this.JogviszonyKeletkezesenekJogcimeId,
                JogviszonyVegeDateFrom = this.JogviszonyVegeDateFrom,
                JogviszonyVegeDateTo = this.JogviszonyVegeDateTo,
                JogviszonyMegszunesenekJogcimeId = this.JogviszonyMegszunesenekJogcimeId,
                JogviszonyTipusId = this.JogviszonyTipusId,
                JogviszonyStatuszId = this.JogviszonyStatuszId
            };
        }
    }
}
