﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloSzakkepzesiJuttatasGridModel : IKretaIdentity
    {
        public const string SzakkepzesiOsztondijExportAttributeId = nameof(SzakkepzesiOsztondijExportAttributeId);
        public const string EgyszeriPalyakezdesiJuttatasExportAttributeId = nameof(EgyszeriPalyakezdesiJuttatasExportAttributeId);

        public TanuloSzakkepzesiJuttatasGridModel()
        {

        }

        public TanuloSzakkepzesiJuttatasGridModel(TanuloSzakkepzesiJuttatasItemCo juttatasCO)
        {
            TanuloNeve = juttatasCO.TanuloNeve;
            AnyjaNeve = juttatasCO.AnyjaNeve;
            SzuletesiHelye = juttatasCO.SzuletesiHelye;
            SzuletesiIdeje = juttatasCO.SzuletesiIdeje;
            EvfolyamNev = juttatasCO.EvfolyamNeve;
            IsJogosultsagText = juttatasCO.Jogosultsag.GetDisplayName();
            NemJogosultsagOka_STR = juttatasCO.NemJogosultsagOka_STR;
            OsztondijOsszege = juttatasCO.JuttatasOsszege??0;
            OktatasiAzonosito = juttatasCO.OktatasiAzonosito;
            NemTanuloiJogviszonyaVan = juttatasCO.NemTanuloiJogviszonyaVan;
            MasodikVagyTobbesSzakmatSzerzo = juttatasCO.MasodikVagyTobbesSzakmatSzerzo;
            Osztaly = juttatasCO.Osztaly;
        }

        public string ID { get; set; }

        [Display(Name = nameof(TanuloResource.TanuloNeve), ResourceType = typeof(TanuloResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 00, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameTanuloNeve), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 00, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameTanuloNeve), typeof(SzakkepzesiJuttatasokResource))]
        public string TanuloNeve { get; set; }

        [Display(Name = nameof(TanuloResource.OktatasiAzonosito), ResourceType = typeof(TanuloResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 01, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOktatasiAzonosito), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 01, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOktatasiAzonosito), typeof(SzakkepzesiJuttatasokResource))]
        public string OktatasiAzonosito { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 02, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameAnyjaNeve), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 02, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameAnyjaNeve), typeof(SzakkepzesiJuttatasokResource))]
        public string AnyjaNeve { get; set; }

        [Display(Name = nameof(TanuloResource.SzuletesiHely), ResourceType = typeof(TanuloResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 03, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameSzuletesiHelye), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 03, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameSzuletesiHelye), typeof(SzakkepzesiJuttatasokResource))]
        public string SzuletesiHelye { get; set; }

        [Display(Name = nameof(TanuloResource.SzuletesiIdo), ResourceType = typeof(TanuloResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 04, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameSzuletesiIdeje), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 04, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameSzuletesiIdeje), typeof(SzakkepzesiJuttatasokResource))]
        public DateTime? SzuletesiIdeje { get; set; }

        [Display(Name = nameof(TanuloResource.Osztaly), ResourceType = typeof(TanuloResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 06, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOsztaly), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 05, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOsztaly), typeof(SzakkepzesiJuttatasokResource))]
        public string Osztaly { get; set; }

        [Display(Name = nameof(TanuloResource.Evfolyam), ResourceType = typeof(TanuloResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 07, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameEvfolyam), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 06, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameEvfolyam), typeof(SzakkepzesiJuttatasokResource))]
        public string EvfolyamNev { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.JuttatasOsszege), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 10, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOsztondijOsszege), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 15, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameOsztondijOsszege), typeof(SzakkepzesiJuttatasokResource))]
        public int OsztondijOsszege { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.NemJogosultsagOka), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public string NemJogosultsagOka_STR { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.Jogosultsag), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 08, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameJogosultsag), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 14, nameof(SzakkepzesiJuttatasokResource.ExportHeaderNameJogosultsag), typeof(SzakkepzesiJuttatasokResource))]
        public string IsJogosultsagText { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 11, nameof(SzakkepzesiJuttatasokResource.NemTanuloiJogviszonyaVan), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 16, nameof(SzakkepzesiJuttatasokResource.NemTanuloiJogviszonyaVan), typeof(SzakkepzesiJuttatasokResource))]
        public string NemTanuloiJogviszonyaVan { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 13, nameof(SzakkepzesiJuttatasokResource.MasodikVagyTobbesSzakmatSzerzo), typeof(SzakkepzesiJuttatasokResource))]
        [SimpleExportColumn(EgyszeriPalyakezdesiJuttatasExportAttributeId, 17, nameof(SzakkepzesiJuttatasokResource.MasodikVagyTobbesSzakmatSzerzo), typeof(SzakkepzesiJuttatasokResource))]
        public string MasodikVagyTobbesSzakmatSzerzo { get; set; }
    }
}
