﻿using System;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloSzakkepzesiOsztondijGridModel : TanuloSzakkepzesiJuttatasGridModel
    {

        public TanuloSzakkepzesiOsztondijGridModel()
        {

        }

        public TanuloSzakkepzesiOsztondijGridModel(TanuloSzakkepzesiOsztondijakItemCo juttatasokCO)
            : base(juttatasokCO)
        {
            TanuloNeve = juttatasokCO.TanuloNeve;
            EvfolyamNev = juttatasokCO.EvfolyamNeve;
            IsJogosultsagText = juttatasokCO.Jogosultsag.GetDisplayName();
            NemJogosultsagOka_STR = juttatasokCO.NemJogosultsagOka_STR;
            OsztondijOsszege = juttatasokCO.JuttatasOsszege??0;
            OktatasiAzonosito = juttatasokCO.OktatasiAzonosito;
            NemTanuloiJogviszonyaVan = juttatasokCO.NemTanuloiJogviszonyaVan;
            AVizsgaltHonapbanNemVoltTanuloiJogviszonya = juttatasokCO.AVizsgaltHonapbanNemVoltTanuloiJogviszonya;
            NemAMegjeloltEvfolyamraVanBesorolva = juttatasokCO.NemAMegjeloltEvfolyamraVanBesorolva;
            MasodikVagyTobbesSzakmatSzerzo = juttatasokCO.MasodikVagyTobbesSzakmatSzerzo;
            BeszamitasosTanulo = juttatasokCO.BeszamitasosTanulo.GetDisplayName();
            Evismetlo = juttatasokCO.Evismetlo;
            IgazolatlanMulasztasokSzama = juttatasokCO.IgazolatlanMulasztasokSzama;
            DualisOktatas = juttatasokCO.DualisOktatas;
            AtlagMinimumAlatt = juttatasokCO.AtlagMinimumAlatt;
            TechnikaiOsztalyTagja = juttatasokCO.TechnikaiOsztalyTagja;
            VendegTanulo = juttatasokCO.VendegTanulo;
            JogviszonySzuneteltetese = juttatasokCO.JogviszonySzuneteltetese;
            KeresztfelevesOsztalyTagja = juttatasokCO.KeresztfelevesOsztalyTagja;
            OsztondijbolKizarva = juttatasokCO.OsztondijbolKizarva;
            MulasztasMiattKizart = juttatasokCO.MulasztasMiattKizart;
            NemSzakmajegyzekSzerintiKepzes = juttatasokCO.NemSzakmajegyzekSzerintiKepzes;
            NemIngyenesKepzesenResztvevo = juttatasokCO.NemIngyenesKepzesenResztvevo;
            Osztaly = juttatasokCO.Osztaly;
            KeziAtlag = juttatasokCO.KeziAtlag;
            SzamitottAtlag = juttatasokCO.SzamitottAtlag;
            FigyelembeVettAtlag = juttatasokCO.KeziAtlag ?? juttatasokCO.SzamitottAtlag;
            Szazalek = juttatasokCO.Szazalek;
            BankszamlaszamMegadva = juttatasokCO.BankszamlaszamMegadva.GetDisplayName();
            Eletkor = juttatasokCO.SzuletesiIdeje.Value.Age(DateTime.Today);
        }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 05, nameof(SzakkepzesiJuttatasokResource.Eletkor), typeof(SzakkepzesiJuttatasokResource))]
        public int Eletkor { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 09, nameof(SzakkepzesiJuttatasokResource.BankszamlaszamMegadva), typeof(SzakkepzesiJuttatasokResource))]
        public string BankszamlaszamMegadva { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 12, nameof(SzakkepzesiJuttatasokResource.AVizsgaltHonapbanNemVoltTanuloiJogviszonya), typeof(SzakkepzesiJuttatasokResource))]
        public string AVizsgaltHonapbanNemVoltTanuloiJogviszonya { get; set; }

        public string NemAMegjeloltEvfolyamraVanBesorolva { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 14, nameof(SzakkepzesiJuttatasokResource.Evismetlo), typeof(SzakkepzesiJuttatasokResource))]
        public string Evismetlo { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 15, nameof(SzakkepzesiJuttatasokResource.IgazolatlanMulasztasokSzama), typeof(SzakkepzesiJuttatasokResource))]
        public string IgazolatlanMulasztasokSzama { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 16, nameof(SzakkepzesiJuttatasokResource.DualisOktatas), typeof(SzakkepzesiJuttatasokResource))]
        public string DualisOktatas { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 17, nameof(SzakkepzesiJuttatasokResource.AtlagMinimumAlatt), typeof(SzakkepzesiJuttatasokResource))]
        public string AtlagMinimumAlatt { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 18, nameof(SzakkepzesiJuttatasokResource.TechnikaiOsztalyTagja), typeof(SzakkepzesiJuttatasokResource))]
        public string TechnikaiOsztalyTagja { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 19, nameof(SzakkepzesiJuttatasokResource.VendegTanulo), typeof(SzakkepzesiJuttatasokResource))]
        public string VendegTanulo { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 20, nameof(SzakkepzesiJuttatasokResource.JogviszonySzuneteltetese), typeof(SzakkepzesiJuttatasokResource))]
        public string JogviszonySzuneteltetese { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 21, nameof(SzakkepzesiJuttatasokResource.KeresztfelevesOsztalyTagja), typeof(SzakkepzesiJuttatasokResource))]
        public string KeresztfelevesOsztalyTagja { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 22, nameof(SzakkepzesiJuttatasokResource.OsztondijbolKizarva), typeof(SzakkepzesiJuttatasokResource))]
        public string OsztondijbolKizarva { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 23, nameof(SzakkepzesiJuttatasokResource.MulasztasMiattKizart), typeof(SzakkepzesiJuttatasokResource))]
        public string MulasztasMiattKizart { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 24, nameof(SzakkepzesiJuttatasokResource.NemSzakmajegyzekSzerintiKepzes), typeof(SzakkepzesiJuttatasokResource))]
        public string NemSzakmajegyzekSzerintiKepzes { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 25, nameof(SzakkepzesiJuttatasokResource.NemIngyenesKepzesenResztvevo), typeof(SzakkepzesiJuttatasokResource))]
        public string NemIngyenesKepzesenResztvevo { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 26, nameof(SzakkepzesiJuttatasokResource.BeszamitasosTanulo), typeof(SzakkepzesiJuttatasokResource))]
        public string BeszamitasosTanulo { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 27, nameof(SzakkepzesiJuttatasokResource.KeziAtlag), typeof(SzakkepzesiJuttatasokResource))]
        public double? KeziAtlag { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 28, nameof(SzakkepzesiJuttatasokResource.SzamitottAtlag), typeof(SzakkepzesiJuttatasokResource))]
        public double? SzamitottAtlag { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 29, nameof(SzakkepzesiJuttatasokResource.FigyelembeVettAtlag), typeof(SzakkepzesiJuttatasokResource))]
        public double? FigyelembeVettAtlag { get; set; }

        [SimpleExportColumn(SzakkepzesiOsztondijExportAttributeId, 30, nameof(SzakkepzesiJuttatasokResource.Szazalek), typeof(SzakkepzesiJuttatasokResource))]
        public int? Szazalek { get; set; }
    }
}
