﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.Tanulo.Models
{
    public class TanuloSzakkepzesiOsztondijSearchModel : TanuloSzakkepzesiJuttatasSearchModel
    {
        [Display(Name = nameof(SzakkepzesiJuttatasokResource.JuttatasOsszege), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public int? JuttatasOsszege { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.Jogosultsag), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public int? Jogosultsag { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.NemJogosultsagOka), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public int? NemJogosultsagOka { get; set; }

        [Display(Name = nameof(TanuloResource.SzuletesiIdo), ResourceType = typeof(TanuloResource))]
        public DateTime? SzuletesiIdoTol { get; set; }
        public DateTime? SzuletesiIdoIg { get; set; }

        public string VizsgaltHonap { get; set; }

        [Display(Name = nameof(SzakkepzesiJuttatasokResource.TanulokMegjelenitese), ResourceType = typeof(SzakkepzesiJuttatasokResource))]
        public int? TanuloTipus { get; set; }

        public TanuloSzakkepzesiOsztondijakKeresesCO ConvertModelToCo()
        {
            return new TanuloSzakkepzesiOsztondijakKeresesCO()
            {
                TanuloNeve = this.TanuloNeve,
                OktatasiAzonosito = this.OktatasiAzonosito,
                SzuletesiIdejeTol = this.SzuletesiIdoTol,
                SzuletesiIdejeIg = this.SzuletesiIdoIg,
                EvfolyamId = this.Evfolyam,
                Jogosultsag = this.Jogosultsag,
                JuttatasOsszege = this.JuttatasOsszege,
                OsztalyId = this.OsztalyId,
                TanuloTipus = this.TanuloTipus
            };
        }
    }
}
